SystemOrganization addCategory: #'EjerciciosPoo-Measure'!

TestCase subclass: #MeasureTest
	instanceVariableNames: 'amount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureTest methodsFor: 'errors' stamp: 'FacundoPippia 5/26/2013 19:31'!
canNotConvertMeasurementException
	
	^ Error ! !

!MeasureTest methodsFor: 'temperature units' stamp: 'FacundoPippia 5/27/2013 02:12'!
celsius
	^ NonProportionalDerivedUnit
		newWithName: 'celsius'
		toBaseFormula: [ :anAmount | anAmount + 273 ]
		fromBaseFormula: [ :anAmount | anAmount - 273 ]
		andBaseUnit: self kelvin! !

!MeasureTest methodsFor: 'distance units' stamp: 'FacundoPippia 5/26/2013 17:32'!
centimeter
	^ ProportionalDerivedUnit newWithName: 'centimeter' factor: 1 / 100 andBaseUnit: self meter! !

!MeasureTest methodsFor: 'time units' stamp: 'FacundoPippia 5/26/2013 18:01'!
day
	

	^ ProportionalDerivedUnit newWithName: 'day' factor: 86400 andBaseUnit: self second.! !

!MeasureTest methodsFor: 'distance units' stamp: 'FacundoPippia 5/26/2013 17:59'!
decameter
	
	^ ProportionalDerivedUnit newWithName: 'decameter' factor: 10 andBaseUnit: self meter.! !

!MeasureTest methodsFor: 'distance units' stamp: 'FacundoPippia 5/26/2013 17:57'!
decimeter
	
	^ ProportionalDerivedUnit newWithName: 'decimeter' factor: 1/10 andBaseUnit: self meter.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceExamples 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'distance units' stamp: 'HernanWilkinson 4/25/2011 17:27'!
distanceUnits 

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'compound measures' stamp: 'FacundoPippia 5/26/2013 21:53'!
eightCubicMeters

	^Measure newWithAmount: 8 andUnit: (MultipliedUnit newWithFactors: (Array with: (self meter) with: (self meter) with: (self meter)))! !

!MeasureTest methodsFor: 'temperature units' stamp: 'FacundoPippia 5/27/2013 02:18'!
fahrenheit
	^ NonProportionalDerivedUnit
		newWithName: 'fahrenheit'
		toBaseFormula: [ :anAmount | anAmount + 241 ]
		fromBaseFormula: [ :anAmount | anAmount - 241 ]
		andBaseUnit: self kelvin! !

!MeasureTest methodsFor: 'compound measures' stamp: 'FacundoPippia 5/27/2013 11:42'!
finalSpeedStartingAt: initialSpeed accelerating: anAcceleration during: aTimePeriod
	"self error: Implementar la formula de velocidad final: vf = vi + a * t"
	^initialSpeed  + (anAcceleration  * aTimePeriod )! !

!MeasureTest methodsFor: 'compound measures' stamp: 'FacundoPippia 5/26/2013 21:41'!
fourSquaredMeters
	^ Measure newWithAmount: 4 andUnit: (MultipliedUnit newWithFactors: (Array with: (self meter) with: (self meter)))! !

!MeasureTest methodsFor: 'compound measures' stamp: 'FacundoPippia 5/27/2013 11:32'!
halfMeterBySecond
	^Measure newWithAmount: 1/2 andUnit: (DividedUnit newWithNumerator: self meter andDenominator: self second).! !

!MeasureTest methodsFor: 'distance units' stamp: 'FacundoPippia 5/26/2013 18:00'!
hectometer
	
	^ ProportionalDerivedUnit newWithName: 'hectometer' factor: 100 andBaseUnit: self meter.! !

!MeasureTest methodsFor: 'time units' stamp: 'FacundoPippia 5/26/2013 18:01'!
hour
	
	^ ProportionalDerivedUnit newWithName: 'hour' factor: 3600 andBaseUnit: self second.! !

!MeasureTest methodsFor: 'temperature units' stamp: 'FacundoPippia 5/27/2013 02:13'!
kelvin
	^ BaseUnit newWithName: 'kelvin'.! !

!MeasureTest methodsFor: 'distance units' stamp: 'FacundoPippia 5/26/2013 18:00'!
kilometer
	
	^ ProportionalDerivedUnit newWithName: 'kilometer' factor: 1000 andBaseUnit: self meter.! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:30'!
measureExamples 

	^ OrderedCollection new
		addAll: self distanceExamples;
		addAll: self temperatureExamples;
		addAll: self timeExamples;
		yourself ! !

!MeasureTest methodsFor: 'distance units' stamp: 'FacundoPippia 5/26/2013 16:08'!
meter

	"unidad estandar esta en metros"

	^ BaseUnit newWithName: 'meter'.! !

!MeasureTest methodsFor: 'distance units' stamp: 'FacundoPippia 5/26/2013 17:58'!
millimeter
	
	^ ProportionalDerivedUnit newWithName: 'milimeter' factor: 1/1000 andBaseUnit: self meter.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'FacundoPippia 5/27/2013 00:22'!
minusOneMeter 
	
	^ Measure newWithAmount: (-1) andUnit: self meter.! !

!MeasureTest methodsFor: 'time units' stamp: 'FacundoPippia 5/26/2013 17:51'!
minute
	^ ProportionalDerivedUnit newWithName: 'minute' factor: 60 andBaseUnit: self second.! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:27'!
objectsInCategoryOf: aSelector

	| category messageNames |
	
	category := self class organization categoryOfElement: aSelector.
	messageNames := (self class organization listAtCategoryNamed:  category) reject: [ :aMessageName | aMessageName = aSelector ].
	
	 ^ messageNames collect: [ :aMessageName | self perform: aMessageName ]
	

	
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'FacundoPippia 5/26/2013 17:09'!
oneCelsius
	
	^ Measure newWithAmount: 1 andUnit: self celsius.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'FacundoPippia 5/27/2013 00:22'!
oneCentimeter
	
	^ Measure newWithAmount: 1 andUnit: self centimeter.! !

!MeasureTest methodsFor: 'time measures' stamp: 'FacundoPippia 5/26/2013 19:10'!
oneDay
	
	^ Measure newWithAmount: 1 andUnit: self day.! !

!MeasureTest methodsFor: 'time measures' stamp: 'FacundoPippia 5/26/2013 19:09'!
oneHour
	
	^ Measure newWithAmount: 1 andUnit: self hour! !

!MeasureTest methodsFor: 'distance measures' stamp: 'FacundoPippia 5/26/2013 17:10'!
oneHundredCentimeters

	^ Measure newWithAmount: 100 andUnit: self centimeter .! !

!MeasureTest methodsFor: 'compound measures' stamp: 'efo 5/2/2011 20:56'!
oneHundredTwentyOneMetersPerSecond

	^self error: 'este metodo debe devolver la medida 121 metro/segundo'! !

!MeasureTest methodsFor: 'distance measures' stamp: 'FacundoPippia 5/26/2013 17:07'!
oneMeter
	
	^ Measure newWithAmount: 1 andUnit: self meter.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'FacundoPippia 5/27/2013 11:37'!
oneMeterPerSecond

	^Measure newWithAmount: 1 andUnit: (DividedUnit newWithNumerator: self meter andDenominator: self second).! !

!MeasureTest methodsFor: 'time measures' stamp: 'FacundoPippia 5/26/2013 17:11'!
oneMinute
	
	^ Measure newWithAmount: 1 andUnit: self minute.! !

!MeasureTest methodsFor: 'time measures' stamp: 'FacundoPippia 5/26/2013 17:08'!
oneSecond

	^ Measure newWithAmount: 1 andUnit:  self second! !

!MeasureTest methodsFor: 'compound measures' stamp: 'FacundoPippia 5/26/2013 21:41'!
oneSquaredMeter
	^ Measure newWithAmount: 1 andUnit: (MultipliedUnit newWithFactors: (Array with: (self meter) with: (self meter)))! !

!MeasureTest methodsFor: 'compound measures' stamp: 'FacundoPippia 5/26/2013 21:54'!
oneSquaredSecond

	^ Measure newWithAmount: 1 andUnit: (MultipliedUnit newWithFactors: (Array with: (self second) with: (self second)))! !

!MeasureTest methodsFor: 'time units' stamp: 'FacundoPippia 5/26/2013 16:40'!
second
	
	^BaseUnit newWithName: 'second'.! !

!MeasureTest methodsFor: 'time measures' stamp: 'FacundoPippia 5/26/2013 19:10'!
sixtyMinutes
	
	^ Measure newWithAmount: 60 andUnit: self minute.! !

!MeasureTest methodsFor: 'time measures' stamp: 'FacundoPippia 5/26/2013 19:40'!
sixtyOneSeconds
	
	^ Measure newWithAmount: 61 andUnit: self second.! !

!MeasureTest methodsFor: 'time measures' stamp: 'FacundoPippia 5/26/2013 17:08'!
sixtySeconds
	
	^ Measure newWithAmount: 60 andUnit: self second.! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'temperature units' stamp: 'HernanWilkinson 4/25/2011 17:28'!
temperatureUnits

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:05'!
test01ObjectsRepresentingSameMeasureShouldBeEqual

	self assert: self oneMeter = self oneMeter.
	self assert: self oneSecond = self oneSecond.
	self assert: self oneCelsius = self oneCelsius.
	

! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:06'!
test02DifferentMeasuresShouldNotBeEqual

	self deny: self oneMeter = self twoMeters.
	self deny: self oneSecond = self sixtySeconds.
	self deny: self oneCelsius = self zeroCelsius.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:07'!
test03SameMeasureExpressWithDifferentUnitsShouldBeEqual

	self assert: self oneMeter = self oneHundredCentimeters.
	self assert: self twoMeters = self twoHundredCentimeters.
	self assert: self oneMinute = self sixtySeconds.
	self assert: self zeroCelsius = self thirtyTwoFahrenheits.
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:08'!
test03aMeasuresOfDifferentDomainShouldNotBeEqual

	self deny: self oneMeter = self oneSecond.
	self deny: self oneMeter = self oneCelsius.
	self deny: self oneCelsius = self oneSecond
! !

!MeasureTest methodsFor: '1 - Test equality' stamp: 'HernanWilkinson 4/25/2011 16:09'!
test04EqualsShouldBeCommutative

	self assert: (self oneMeter = self oneHundredCentimeters and: [ self oneHundredCentimeters = self oneMeter ]).
	self assert: (self twoMeters = self twoHundredCentimeters and:  [ self twoHundredCentimeters = self twoMeters ]).
	self assert: (self oneMinute = self sixtySeconds and: [self sixtySeconds = self oneMinute]).
	self assert: (self zeroCelsius = self thirtyTwoFahrenheits and: [ self thirtyTwoFahrenheits = self zeroCelsius]).
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:11'!
test05UnitStringRepresentationShouldBeHumanReadable

	self assert: self meter printString = 'meter'.
	self assert: self centimeter printString = 'centimeter'.
	self assert: self decimeter printString = 'decimeter'.
	self assert: self millimeter printString = 'milimeter'.
	self assert: self decameter printString = 'decameter'.
	self assert: self hectometer printString = 'hectometer'.
	self assert: self kilometer printString = 'kilometer'.	
	
	self assert: self celsius printString = 'celsius'.	
	self assert: self fahrenheit printString = 'fahrenheit'.	

	self assert: self day printString = 'day'.	
	self assert: self hour printString = 'hour'.	
	self assert: self minute printString = 'minute'.	
	self assert: self second printString = 'second'.	

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'FacundoPippia 5/20/2013 21:50'!
test06MeasureStringRepresentationShouldBeHumanReadable

	self assert: self oneMeter printString = '1 meter'.
	self assert: self twoMeters printString = '2 meters'.
	self assert: self oneHundredCentimeters printString = '100 centimeters'.
	
	self assert: self oneMinute printString = '1 minute'.
	self assert: self sixtySeconds printString = '60 seconds'.
	
	self assert: self zeroCelsius printString = '0 celsius'.
	self assert: self thirtyTwoFahrenheits printString = '32 fahrenheits'.
	
	
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:14'!
test07aMeasureAmountShouldBeTheExpectedAmount

	self assert: self oneMeter amount = 1.
	self assert: self twoMeters amount = 2.
	self assert: self oneHundredCentimeters amount = 100.
	self assert: self twoHundredCentimeters amount = 200.

	self assert: self oneMinute amount = 1.
	self assert: self sixtySeconds amount = 60.
	
	self assert: self zeroCelsius amount = 0.
	self assert: self thirtyTwoFahrenheits amount = 32.
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07bMeasureUnitShouldBeTheExpectedUnit

	self assert: self oneMeter unit = self meter.
	self assert: self twoMeters unit = self meter.
	self assert: self oneHundredCentimeters unit = self centimeter.
	self assert: self twoHundredCentimeters unit = self centimeter.
	
	self assert: self oneMinute unit = self minute.
	self assert: self sixtySeconds unit = self second.
	
	self assert: self zeroCelsius unit = self celsius.
	self assert: self thirtyTwoFahrenheits unit = self fahrenheit
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:15'!
test07cDifferentMeasureUnitsShouldBeDifferent

	| unitsGroupedByItself |
	
	unitsGroupedByItself := self units groupedBy: [ :aUnit | aUnit ].
	self assert: (unitsGroupedByItself allSatisfy: [:aCollectionOfUnit | aCollectionOfUnit size = 1] )
! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:03'!
test07dDistancesCanBeConvertedToDifferentUnits

	"A partir de los test de igualdad, se deben haber dado cuenta que debemos poder
	convertir distancias a distintas unidades... y que ademas dos distancias de distintas unidades
	pueden ser iguales... Por lo tanto por qu no hacer esta caracteristica de las distancias explicita?
	Veran que luego se torna muy util
	
	Respecto de como esta escrito el test, para no tener que escribir los assert para oneMeter y oneHundredCentimeters 
	creo un array y lo recorro... Se podria escribir menos aun en este test?
	
	Y por qu se asserta sobre el amount y luego la unidad y no directametne sobre la distancia completa. ej:
	self assert: (aDistance converTo: self meter) = self oneMeter
	"
	
	(Array with: self oneMeter with: self oneHundredCentimeters) do: [ :aDistance |
		self assert: (aDistance convertTo: self meter) amount = 1.
		self assert: (aDistance convertTo: self meter) unit = self meter.
		
		self assert: (aDistance convertTo: self decimeter) amount = 10.
		self assert: (aDistance convertTo: self decimeter) unit = self decimeter.
		
		self assert: (aDistance convertTo: self centimeter) amount = 100.
		self assert: (aDistance convertTo: self centimeter) unit = self centimeter.
		
		self assert: (aDistance convertTo: self millimeter) amount = 1000.
		self assert: (aDistance convertTo: self millimeter) unit = self millimeter.
	
		self assert: (aDistance convertTo: self decameter) amount = (1/10).
		self assert: (aDistance convertTo: self decameter) unit = self decameter.
		
		self assert: (aDistance convertTo: self hectometer) amount = (1/100).
		self assert: (aDistance convertTo: self hectometer) unit = self hectometer.
	
		self assert: (aDistance convertTo: self kilometer) amount = (1/1000).
		self assert: (aDistance convertTo: self kilometer) unit = self kilometer ]! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07eTimeMeasuresCanBeConvertedToDifferentUnits

	self assert: (self oneMinute convertTo: self second) = self sixtySeconds.
	self assert: (self sixtySeconds convertTo: self minute) = self oneMinute.

	self assert: (self oneHour convertTo: self minute) = self sixtyMinutes.
	self assert: (self sixtyMinutes convertTo: self hour) = self oneHour.

	self assert: (self oneDay convertTo: self hour) = self twentyFourHours.
	self assert: (self twentyFourHours convertTo: self day) = self oneDay.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:17'!
test07fTemperatureMeasuresCanBeConvertedToDifferentUnits

	self assert: (self zeroCelsius convertTo: self fahrenheit) = self thirtyTwoFahrenheits.
	self assert: (self thirtyTwoFahrenheits convertTo: self celsius) = self zeroCelsius.

! !

!MeasureTest methodsFor: '2 - Converting/accessing/printing' stamp: 'HernanWilkinson 4/25/2011 16:19'!
test07gMeasuresCanNotBeConvertedToUnitsOfDifferentDomain

	self should: [ self oneMeter convertTo: self second ] raise: self canNotConvertMeasurementException.
	self should: [ self oneSecond convertTo: self celsius ] raise: self canNotConvertMeasurementException.
	self should: [ self oneCelsius convertTo: self centimeter ] raise: self canNotConvertMeasurementException.


! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:20'!
test08aComparingMeasuresWithOtherObjectsShouldReturnFalse

	"El igual no debe generar ningun tipo de error por mas que se comparen objetos
	de distintos tipos
	Fijense como se crea una instancia de Object sin ningun tipo de problema... qu representa?"

	self deny: self oneMeter = Object new.
	self deny: Object new = self oneMeter! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08bMeasuresThatAreEqualShouldReturnTheSameHash

	"Debido a como funcionan los diccionarios, cuando dos objetos son iguales deben
	tener es mismo hash. La inversa no es verdad"
	
	self assert: self oneMeter hash=self oneMeter hash.
	self assert: self oneMeter hash=self oneHundredCentimeters hash.
	self assert: self oneMinute hash = self sixtySeconds hash.
	self assert: self zeroCelsius hash = self thirtyTwoFahrenheits hash.
	
	
! !

!MeasureTest methodsFor: '3 - Test equality - implementation details' stamp: 'HernanWilkinson 4/25/2011 16:21'!
test08cCopiesOfTheSameMeasureShouldBeEqual

	"Dos objetos que ocupan distintas posiciones de memoria pero representan
	la misma entidad de la realidad, deben devolver true cuando se los compara por igual, puesto
	que representan la misma entidad de la realidad.
	Por lo tanto, el mensaje #= significa 'representan el mismo ente de la realidad?'
	mientras que el mensaje #== significa ocupan la misma posicion de memoria?"

	| originalOneMeter copiedOneMeter |

	"Al objeto oneMeter lo copio para asegurarme de tener uno oneMeter en otra posicion de memoria"

	originalOneMeter := self oneMeter.
	copiedOneMeter := originalOneMeter copy.

	"Me aseguro que ocupen distinta posicion de memoria"
	self deny: originalOneMeter == copiedOneMeter.

	"Ahora me aseguro que sean iguales"
	self assert: originalOneMeter = copiedOneMeter! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:31'!
test09AddingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneMeter) = self twoMeters.
	self assert: (self oneSecond + self oneSecond) = self twoSeconds.
	self assert: (self oneCelsius + self oneCelsius) = self twoCelsius.
	

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test10AddingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheAddingMeasures

	self assert: (self oneMeter + self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneMeter + self oneHundredCentimeters) = self twoHundredCentimeters.
	self assert: (self oneSecond + self oneMinute) = self sixtyOneSeconds.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test10aCanNotAddMeasuresOfDifferentDomain

	self should: [ self oneMeter + self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:32'!
test11AddingMeasuresIsCommutative

	self assert: (self oneMeter + self twoMeters)=(self twoMeters + self oneMeter).
	self assert: (self oneSecond + self twoSeconds)=(self twoSeconds + self oneSecond).
	self assert: (self oneCelsius + self twoCelsius)=(self twoCelsius + self oneCelsius)
	


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:33'!
test12AddingMeasuresIsAssociative

	self assert: 
		((self oneMeter + self oneMeter) + self twoMeters) = 
		(self oneMeter + (self oneMeter + self twoMeters)).

	self assert: 
		((self oneSecond + self oneSecond) + self twoSeconds) = 
		(self oneSecond + (self oneSecond + self twoSeconds)).

	self assert: 
		((self oneCelsius + self oneCelsius) + self twoCelsius) = 
		(self oneCelsius + (self oneCelsius + self twoCelsius)).

		

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:35'!
test12aAddingMeasuresKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter + oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond + oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius + oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 



! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13aNegatingAMeasureNegatesItsAmount

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated amount=aMeasure amount negated ]
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:36'!
test13bNegatingAMeasureIsReflective

	(Array with: self oneMeter with: self twoSeconds with: self thirtyTwoFahrenheits) do: [:aMeasure |
		self assert: aMeasure negated negated=aMeasure ].
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:37'!
test14SubtractingMeasuresOfSameUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneMeter) = self oneMeter.
	self assert: (self oneMeter - self oneMeter) = self zeroMeters.
	self assert: (self oneMeter - self twoMeters) = self oneMeter negated.
	
	self assert: (self twoSeconds - self oneSecond) = self oneSecond.
	self assert: (self oneSecond - self oneSecond) = self zeroSeconds.
	self assert: (self oneSecond - self twoSeconds) = self oneSecond negated.
	
	self assert: (self twoCelsius - self oneCelsius) = self oneCelsius.
	self assert: (self oneCelsius - self oneCelsius) = self zeroCelsius.
	self assert: (self oneCelsius - self twoCelsius) = self oneCelsius negated.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test15SubtractingMeasuresOfDifferentUnitShouldReturnAMeasureRepresentingTheSubtractedMeasures

	self assert: (self twoMeters - self oneHundredCentimeters) = self oneMeter.
	self assert: (self oneMeter - self oneHundredCentimeters) = self zeroMeters.
	self assert: (self oneHundredCentimeters - self twoMeters) = self oneMeter negated.
	
	self assert: (self sixtyOneSeconds - self oneMinute) = self oneSecond.
	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:48'!
test15aCanNotSubtractMeasuresOfDifferentDomain

	self should: [ self oneMeter - self oneSecond ] raise: self canNotConvertMeasurementException 

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:38'!
test16SubtractingMeasuresIsAssociative

	self assert: 
		((self twoMeters - self oneMeter) - self oneMeter) = 
		(self twoMeters - (self oneMeter + self oneMeter)).

	self assert: 
		((self twoSeconds - self oneSecond) - self oneSecond) = 
		(self twoSeconds - (self oneSecond + self oneSecond)).	

	

	! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:39'!
test16aSubtractingMeasuresKeepsMeasuresImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter - oneMeter.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond - oneSecond.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius - oneCelsius.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17aMeasuresCanBeMultiplyByAnInteger

	self assert: self oneMeter * 1 = self oneMeter.
	self assert: self oneMeter * 2 = self twoMeters.
	self assert: self oneMeter * 0 = self zeroMeters.

	self assert: self oneSecond * 1 = self oneSecond.
	self assert: self oneSecond * 2 = self twoSeconds.
	self assert: self oneSecond * 0 = self zeroSeconds.

	self assert: self oneCelsius * 1 = self oneCelsius.
	self assert: self oneCelsius * 2 = self twoCelsius.
	self assert: self oneCelsius * 0 = self zeroCelsius.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:40'!
test17bMeasuresCanBeMultiplyByAFraction

	self assert: (self oneMeter * (2/3)) amount = (2/3).
	self assert: (self twoMeters * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneSecond * (2/3)) amount = (2/3).
	self assert: (self twoSeconds * (2/3)) amount = (2 * (2/3)).

	self assert: (self oneCelsius * (2/3)) amount = (2/3).
	self assert: (self twoCelsius * (2/3)) amount = (2 * (2/3)).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:41'!
test17cMeasuresCanBeMultiplyByAFloat

	self assert: (self oneMeter * 2.5) amount = 2.5.
	self assert: (self twoMeters * 2.5) amount = (2 * 2.5).

	self assert: (self oneSecond * 2.5) amount = 2.5.
	self assert: (self twoSeconds * 2.5) amount = (2 * 2.5).

	self assert: (self oneCelsius * 2.5) amount = 2.5.
	self assert: (self twoCelsius * 2.5) amount = (2 * 2.5).
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:45'!
test17dMeasuresCanBeMultiplyByAMeasureOfSameDomain

	self assert: (self oneMeter * self oneMeter) = self oneSquaredMeter.
	self assert: (self twoMeters * self twoMeters) = self fourSquaredMeters.
	self assert: (self twoMeters * self twoMeters * self twoMeters) = self eightCubicMeters.

	self assert: (self oneSecond * self oneSecond) = self oneSquaredSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:53'!
test17eMeasuresCanBeMultiplyByAMeasureOfDifferentDomain

	self assert: (self oneMeter * self twoSeconds) = self twoMetersTimesSecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:42'!
test18MultiplicationKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter * 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond * 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius * 2.
	
	self assert: oneCelsius = self oneCelsius 




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:49'!
test19aMeasuresCanBeDividedByAnInteger

	self assert: (self oneMeter / 1) = self oneMeter.
	self assert: (self twoMeters / 2) = self oneMeter.

	self assert: (self oneSecond / 1) = self oneSecond.
	self assert: (self twoSeconds / 2) = self oneSecond.

	self assert: (self oneCelsius / 1) = self oneCelsius.
	self assert: (self twoCelsius / 2) = self oneCelsius.

! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19bMeasuresCanBeDividedByAFraction

	self assert: (self twoMeters / (1/3)) amount = 6.
	self assert: (self twoSeconds / (1/3)) amount = 6.
	self assert: (self twoCelsius / (1/3)) amount = 6.




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:50'!
test19cMeasuresCanBeDividedByAFloat

	self assert: (self twoMeters / 2.5) amount = (2/2.5).
	self assert: (self twoSeconds / 2.5) amount = (2/2.5).
	self assert: (self twoCelsius / 2.5) amount = (2/2.5).




! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'FacundoPippia 5/27/2013 07:30'!
test19dMeasuresCanBeDividedByAMeasureOfSameDomain


	self assert: (self oneMeter / self oneMeter) = 1.
	self assert: (self twoMeters / self oneMeter) = 2.
		
	self assert: (self oneSecond / self oneSecond) = 1.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'FacundoPippia 5/27/2013 11:31'!
test19eMeasuresCanBeDividedByAMeasureOfDifferentDomain

	self assert: (self oneMeter / self twoSeconds) = self halfMeterBySecond.
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 16:54'!
test20DivisionKeepsMeasureImmutability

	| oneMeter oneSecond oneCelsius |
	
	oneMeter := self oneMeter.
	oneMeter / 2.
	
	self assert: oneMeter = self oneMeter.
	
	oneSecond := self oneSecond.
	oneSecond / 2.
	
	self assert: oneSecond = self oneSecond.
	
	oneCelsius := self oneCelsius.
	oneCelsius / 2.
	
	self assert: oneCelsius = self oneCelsius 


! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'efo 5/2/2011 20:56'!
test20aFinalSpeedCanBeRepresentedWithMeasures

	self assert: 
		(self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = 
		(self oneMeterPerSecond + (self twoMetersPerSquaredSecond * self sixtySeconds)).
		
	self assert: (self finalSpeedStartingAt: self oneMeterPerSecond accelerating: self twoMetersPerSquaredSecond during: self sixtySeconds) = self oneHundredTwentyOneMetersPerSecond 
	
! !

!MeasureTest methodsFor: '4 - Test arithmetic operations' stamp: 'HernanWilkinson 4/25/2011 17:00'!
test20bMultiplyingANumberByAUnitReturnsAMeasure

	self assert: (1*self meter) = self oneMeter.
	self assert: (2*self second) = self twoSeconds.
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:02'!
test21MeasuresProvideATotalOrder

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure < (aMeasure + (1* aMeasure unit))])

! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:03'!
test22MeasuresCanBeComparedWithGreaterThan

	self assert: (self measureExamples allSatisfy: [ :aMeasure | (aMeasure + (1 * aMeasure unit)) > aMeasure ])
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:04'!
test23MeasuresCanBeComparedWithLessThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure <= aMeasure and: [aMeasure <= (aMeasure + (1 * aMeasure unit))]])

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test24MeasuresCanBeComparedWithGreaterThanOrEqual

	self assert: (self measureExamples allSatisfy: [ :aMeasure | aMeasure >= aMeasure and: [(aMeasure + (1 * aMeasure unit)) >= aMeasure]])! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test25MaxReturnsTheMaximumBetweenTwoMeasures

	self assert: (self twoMeters max: self oneMeter) = self twoMeters.
	self assert: (self oneMeter max: self twoMeters) = self twoMeters.

	self assert: (self twoMeters max: self oneHundredCentimeters) = self twoMeters.
	self assert: (self oneHundredCentimeters max: self twoMeters) = self twoMeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test26MinReturnsTheMinimumBetweenTwoMeasures

	self assert: (self twoMeters min: self oneMeter) = self oneMeter.
	self assert: (self oneMeter min: self twoMeters) = self oneMeter.

	self assert: (self twoMeters min: self oneHundredCentimeters) = self oneHundredCentimeters.
	self assert: (self oneHundredCentimeters min: self twoMeters) = self oneHundredCentimeters.

	
! !

!MeasureTest methodsFor: '5 - Test magnitude protocol' stamp: 'HernanWilkinson 4/25/2011 17:05'!
test27BetweenAndReturnsTrueIfAMeasureIsBetweenOtherTwoMeasures

	self assert: (self oneMeter between: self zeroMeters and: self twoMeters).
	self assert: (self oneHundredCentimeters between: self zeroMeters and: self twoMeters).
	
	self deny: (self twoMeters between: self zeroMeters and: self oneMeter).
	self deny: (self twoHundredCentimeters between: self zeroMeters and: self oneMeter).

! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:09'!
test28IntervalOfMeasuresCanBeCreatedBecauseTheyDefineATotalOrder

	self assert: (self oneMeter to: self twoMeters) first=self oneMeter.
	self assert: (self oneMeter to: self twoMeters) last=self twoMeters.
	self assert: (self oneMeter to: self twoMeters) increment =self oneMeter.	

	self assert: (self oneHundredCentimeters to: self twoMeters) first=self oneMeter.
	self assert: (self oneHundredCentimeters to: self twoMeters) last=self twoMeters.
	self assert: (self oneHundredCentimeters to: self twoMeters) increment=self oneCentimeter.	
	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:16'!
test29MeasureIntervalStepCanBeAnyMeasure

	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) first=self zeroMeters.
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) last=(self twoMeters * 2).
	self assert: (self zeroMeters to: (self twoMeters * 2) by: self twoMeters) increment=self twoMeters.

	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) first=(self twoMeters * 2).
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) last=self zeroMeters.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self twoMeters negated) increment=self twoMeters negated

	! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test30MeasureIntervalSizeReturnsTheNumberOfMeasuresOfTheInterval

	self assert: (self zeroMeters to: (self twoMeters * 2) ) size =5.
	self assert: ((self twoMeters * 2) to: self zeroMeters by: self oneMeter negated) size =5.
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:17'!
test31MeasureIntervalCanBeEnumeratedUsingDo

	| value |
	
	value := 1.
	(self oneMeter to: (self oneMeter * 10)) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + 1 ].
	
	self assert: value = 11
! !

!MeasureTest methodsFor: '6 - Test interval protocol' stamp: 'HernanWilkinson 4/25/2011 17:18'!
test32MeasureIntervalCanBeEnumeratedWithSpecificStep

	| value initialDistance byDistance finalDistance |
	
	initialDistance := self oneMeter.
	byDistance := self twoMeters.
	finalDistance := initialDistance * 9.
	value := initialDistance amount.
		
	(initialDistance to: finalDistance by:  byDistance) do: [ :aMeasure |
		self assert: aMeasure amount = value.
		value := value + byDistance amount ].
	
	self assert:  value = (finalDistance amount + byDistance amount)
! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:20'!
test33NothingOnAnyDomainAreEquals

	self assert: self zeroMeters = self zeroSeconds.
	self assert: self zeroSeconds = self zeroKelvin.
	self assert: self zeroKelvin = self zeroMeters! !

!MeasureTest methodsFor: '7 - Polymorphic zero' stamp: 'HernanWilkinson 4/25/2011 17:42'!
test34ZeroCelsiusIsNotNothingOnTemperature

	self deny: self zeroCelsius = self zeroKelvin.
	self deny: self zeroSeconds = self zeroCelsius.
! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'FacundoPippia 5/26/2013 17:15'!
thirtyTwoFahrenheits
	
	^ Measure newWithAmount: 32 andUnit: self fahrenheit.! !

!MeasureTest methodsFor: 'time measures' stamp: 'HernanWilkinson 4/25/2011 17:29'!
timeExamples

	^self objectsInCategoryOf: thisContext method selector.
	
! !

!MeasureTest methodsFor: 'time units' stamp: 'HernanWilkinson 4/29/2011 17:10'!
timeUnits

	^self objectsInCategoryOf: thisContext method selector.
	
 ! !

!MeasureTest methodsFor: 'time measures' stamp: 'FacundoPippia 5/26/2013 19:11'!
twentyFourHours
	
	^ Measure newWithAmount: 24 andUnit: self hour.! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'FacundoPippia 5/26/2013 19:39'!
twoCelsius
	
	^ Measure newWithAmount: 2 andUnit: self celsius.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'FacundoPippia 5/26/2013 17:11'!
twoHundredCentimeters
	
	^ Measure newWithAmount: 200 andUnit: self centimeter.! !

!MeasureTest methodsFor: 'distance measures' stamp: 'FacundoPippia 5/26/2013 17:07'!
twoMeters
	
	^ Measure newWithAmount: 2 andUnit: self meter.! !

!MeasureTest methodsFor: 'compound measures' stamp: 'FacundoPippia 5/27/2013 11:11'!
twoMetersBySecond

	^Measure newWithAmount: 2 andUnit: (DividedUnit newWithNumerator: self meter andDenominator: self second).! !

!MeasureTest methodsFor: 'compound measures' stamp: 'FacundoPippia 5/27/2013 11:40'!
twoMetersPerSquaredSecond

  "este metodo debe devolver la medida 2 metros/segundoAlCuadrado"

	^Measure newWithAmount: 2 andUnit: (DividedUnit newWithNumerator: self meter andDenominator: self oneSquaredSecond).
! !

!MeasureTest methodsFor: 'compound measures' stamp: 'FacundoPippia 5/26/2013 22:00'!
twoMetersTimesSecond

	^ Measure newWithAmount: 2 andUnit: (MultipliedUnit newWithFactors: (Array with: (self meter) with: (self second)))! !

!MeasureTest methodsFor: 'time measures' stamp: 'FacundoPippia 5/26/2013 19:39'!
twoSeconds
	
	^ Measure newWithAmount: 2 andUnit: self second.! !

!MeasureTest methodsFor: 'objects in category' stamp: 'HernanWilkinson 4/25/2011 17:34'!
units 

	^ OrderedCollection new
		addAll: self distanceUnits;
		addAll: self temperatureUnits;
		addAll: self timeUnits;
		yourself ! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'FacundoPippia 5/27/2013 01:35'!
zeroCelsius
	
	^ Measure newWithAmount: 0 andUnit: self celsius.! !

!MeasureTest methodsFor: 'temperature measures' stamp: 'FacundoPippia 5/27/2013 01:52'!
zeroKelvin
	
	^ NullMeasure newWithUnit: self kelvin  ! !

!MeasureTest methodsFor: 'distance measures' stamp: 'FacundoPippia 5/27/2013 01:53'!
zeroMeters

	^ NullMeasure newWithUnit: self meter! !

!MeasureTest methodsFor: 'time measures' stamp: 'FacundoPippia 5/27/2013 01:53'!
zeroSeconds
	
	^ NullMeasure newWithUnit: self second.! !

Object subclass: #Measure
	uses: TComparable - {#min:max:}
	instanceVariableNames: 'amount unit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

Measure class
	uses: TComparable classTrait
	instanceVariableNames: ''!

!Measure class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 17:07'!
newWithAmount: anAmount andUnit: aUnit
^ self new initializeAmount: anAmount unit:  aUnit! !

!Measure methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 21:24'!
* aMeasure 
	
	^ Measure newWithAmount: (self amount * (aMeasure amount)) andUnit: (self unit * (aMeasure unit)).! !

!Measure methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 19:38'!
+ aMeasure 
	| convertedMeasure |
   	
	convertedMeasure := aMeasure convertTo: self unit.

	^Measure newWithAmount:  (self amount + (convertedMeasure amount)) andUnit: self unit.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 19:43'!
- aMeasure
	 
	^self + (aMeasure negated ).! !

!Measure methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 23:02'!
/ aMeasure

	^ Measure newWithAmount: (self amount / (aMeasure amount)) andUnit: (self unit / (aMeasure unit)).! !

!Measure methodsFor: 'comparing' stamp: 'FacundoPippia 5/27/2013 01:02'!
< aMeasure
	|convertedMeasure|
  	 convertedMeasure:=	aMeasure convertTo: self unit.
	^ self amount < convertedMeasure amount! !

!Measure methodsFor: 'comparing' stamp: 'FacundoPippia 5/27/2013 07:53'!
= aMeasure
	
	( ( aMeasure isKindOf: Measure) or:  (aMeasure isKindOf: Number)) ifTrue: 
	[^ (((self unit convertAmountBaseUnit: (self amount)) = (aMeasure unit convertAmountBaseUnit: (aMeasure amount))) and: (self unit baseUnit = aMeasure unit baseUnit))].
	^ false! !

!Measure methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/20/2013 20:12'!
amount

	^ amount! !

!Measure methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 17:19'!
baseUnit
	self shouldBeImplemented.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 19:30'!
convertTo: anUnit 
	(self unit baseUnit = anUnit baseUnit) ifFalse: [ Error signal: 'Cannot convert different units' ].
	^ Measure newWithAmount: (anUnit convertAmountFromBaseUnit: (self unit convertAmountBaseUnit: self amount)) andUnit: anUnit.
"	^Distance amount:  (amount * unit convertionFactor ) / (anUnit convertionFactor )  unit: anUnit ."! !

!Measure methodsFor: 'comparing' stamp: 'FacundoPippia 5/26/2013 19:35'!
hash 
^ (unit convertAmountBaseUnit: (amount)) hash.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/20/2013 20:12'!
initializeAmount: anAmount unit: aUnit
 amount:= anAmount .
 unit:= aUnit.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 19:42'!
negated
^ Measure newWithAmount: (self amount * -1) andUnit: self unit.! !

!Measure methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 14:59'!
printString
	(unit printString last asString = 's') ifTrue:
	[^amount printString , ' ' ,unit printString].
	^amount printString , ' ' ,unit printString asPluralBasedOn: amount.
! !

!Measure methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 01:11'!
to: aMeasure
	
	| convertedMeasure |
	
	convertedMeasure := aMeasure convertTo: self unit.
	^ MeasureInterval newFrom: self to: convertedMeasure. ! !

!Measure methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 01:18'!
to: toMeasure by: byMeasure
	^ MeasureInterval newFrom: self to: toMeasure by: byMeasure! !

!Measure methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/20/2013 20:12'!
unit

	^ unit! !

Measure subclass: #NullMeasure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!NullMeasure class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 01:50'!
newWithUnit: aUnit 
	^ NullMeasure new initializeWithUnit: aUnit.! !

!NullMeasure methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 01:58'!
= aMeasure
	"comment stating purpose of message"

	^ (aMeasure unit convertAmountBaseUnit: aMeasure amount) = 0.! !

!NullMeasure methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 01:51'!
initializeWithUnit: aUnit
	amount := 0.
	unit := aUnit.
	^self! !

Object subclass: #MeasureInterval
	instanceVariableNames: 'from to by'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MeasureInterval class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 01:15'!
newFrom: aMeasure to: anotherMeasure
	^ MeasureInterval new initializeFrom: aMeasure to: anotherMeasure .! !

!MeasureInterval class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 01:20'!
newFrom: fromMeasure to: toMeasure by: byMeasure
	^ MeasureInterval new initializeFrom: fromMeasure to: toMeasure by: byMeasure.! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/20/2013 20:13'!
by
	^by! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/20/2013 20:13'!
do: aBlockClosure 
    
    | index |
    
    index := from.
    [ index <= to] whileTrue: 
        [ 
        	aBlockClosure value: index. 
	  	index:= index + by.
        ]! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 01:08'!
first
	^ from! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/20/2013 20:13'!
from
	^ from! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 01:16'!
increment
	^by! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 01:14'!
initializeFrom: fromMeasure to: toMeasure
	from := fromMeasure.
	to := toMeasure.
	by := Measure newWithAmount: 1 andUnit: (from unit).
	^ self.! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 01:15'!
initializeFrom: fromMeasure to: toMeasure by: stepMeasure
	from := fromMeasure.
	to := toMeasure.
	by := stepMeasure.
	^ self.! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 01:08'!
last
	^ to! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 01:07'!
size 
	 ^((((to - from) convertTo: (by unit)) / by amount) amount) + ((Measure newWithAmount:  1 andUnit: (by unit)  ) amount)! !

!MeasureInterval methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/20/2013 20:13'!
to
	^ to! !

Object subclass: #Unit
	instanceVariableNames: 'name baseUnit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

Unit subclass: #BaseUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!BaseUnit class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 16:09'!
newWithName: aName
	"comment stating purpose of message"

	^ BaseUnit new initializeWithName: aName.! !

!BaseUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 17:38'!
= anObject 
	
      ( anObject isKindOf: BaseUnit) ifTrue: 
	[^ (self name = anObject name)].
	^ false! !

!BaseUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 16:37'!
convertAmountBaseUnit: aNumber 
	"comment stating purpose of message"

	^ aNumber.! !

!BaseUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 19:00'!
convertAmountFromBaseUnit: aNumber 
	"comment stating purpose of message"

	^ aNumber.! !

!BaseUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 21:07'!
initializeWithName: aName
	"comment stating purpose of message"

	name := aName.
	baseUnit := self.
	^ self.! !

!BaseUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 21:50'!
multipliedUnitFrom: aUnit
	^ MultipliedUnit newWithFactors: (Array with: self with: aUnit)! !

Unit subclass: #CompoundUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

CompoundUnit subclass: #DividedUnit
	instanceVariableNames: 'numerator denominator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!DividedUnit class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 23:19'!
newWithNumerator: aNumerator andDenominator: aDenominator
	^ DividedUnit new initializeWithNumerator: aNumerator andDenominator: aDenominator.! !

!DividedUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 11:23'!
= anObject 
	
	 ( anObject isKindOf: DividedUnit ) ifTrue: 
	[^ self  numerator= anObject  numerator and: self denominator = anObject denominator].
	^ false! !

!DividedUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 11:09'!
baseUnit

	^ DividedUnit newWithNumerator: numerator  baseUnit  andDenominator: denominator  baseUnit ! !

!DividedUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 11:24'!
denominator

	^ denominator! !

!DividedUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 23:18'!
initializeWithNumerator: aNumerator andDenominator: aDenominator 
	numerator := aNumerator.
	denominator := aDenominator.! !

!DividedUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 11:24'!
numerator
	
	^ numerator! !

!DividedUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 17:34'!
simplify
	
( denominator isKindOf: NullUnit) ifTrue: 
	[^numerator . ].
	^ self.! !

CompoundUnit subclass: #MultipliedUnit
	instanceVariableNames: 'factors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!MultipliedUnit class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 21:37'!
newWithFactors: factorArray 
	^MultipliedUnit new initilizeWithFactors: factorArray .! !

!MultipliedUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 21:20'!
convertAmountBaseUnit: anAmount
	"comment stating purpose of message"
	| amountInBaseUnit |
	
	amountInBaseUnit := 1.
	factors do: [ :aUnit | amountInBaseUnit := amountInBaseUnit * (aUnit convertAmountBaseUnit: anAmount) ].
	
	^ amountInBaseUnit! !

!MultipliedUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 21:35'!
initilizeWithFactors: factorArray  
	factors := factorArray.
	^self! !

Unit subclass: #DerivedUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!DerivedUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 18:06'!
= anObject 
	
      ( anObject isKindOf: DerivedUnit) ifTrue: 
	[^ (self name = anObject name) and: (self baseUnit = anObject baseUnit)].
	^ false! !

!DerivedUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 21:37'!
multipliedUnitFrom: aUnit
	^ MultipliedUnit newWithFactors: self! !

DerivedUnit subclass: #NonProportionalDerivedUnit
	instanceVariableNames: 'toBaseFormula fromBaseFormula'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!NonProportionalDerivedUnit class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 19:20'!
newWithName: aName toBaseFormula: aToBaseFormula fromBaseFormula: aFromBaseFormula andBaseUnit: aBaseUnit
	^ NonProportionalDerivedUnit new initializeWithName: aName toBaseFormula: aToBaseFormula fromBaseFormula: aFromBaseFormula andBaseUnit: aBaseUnit.! !

!NonProportionalDerivedUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 19:01'!
convertAmountBaseUnit: aNumber
	"comment stating purpose of message"

	^ toBaseFormula value: aNumber! !

!NonProportionalDerivedUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 19:25'!
convertAmountFromBaseUnit: aNumber
	"comment stating purpose of message"
	
	^ fromBaseFormula value: aNumber! !

!NonProportionalDerivedUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 18:33'!
initializeWithName: aName toBaseFormula: aToBaseFormula fromBaseFormula: aFromBaseFormula andBaseUnit: aBaseUnit
	name := aName.
	toBaseFormula := aToBaseFormula .
	fromBaseFormula := aFromBaseFormula .
	baseUnit := aBaseUnit
	! !

DerivedUnit subclass: #ProportionalDerivedUnit
	instanceVariableNames: 'convertionFactor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!ProportionalDerivedUnit class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 17:41'!
newWithName: aName factor: aConvertionFactor andBaseUnit: aBaseUnit
	^ ProportionalDerivedUnit new initializeWithName: aName factor: aConvertionFactor andBaseUnit: aBaseUnit! !

!ProportionalDerivedUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 16:37'!
convertAmountBaseUnit: aNumber
	"comment stating purpose of message"

	^ aNumber * convertionFactor.! !

!ProportionalDerivedUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 19:02'!
convertAmountFromBaseUnit: aNumber
	"comment stating purpose of message"

	^ aNumber / convertionFactor.! !

!ProportionalDerivedUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 17:40'!
initializeWithName: aName factor: aConvertionFactor andBaseUnit: aBaseUnit
	"comment stating purpose of message"

	name := aName.
	convertionFactor := aConvertionFactor.
	baseUnit := aBaseUnit.! !

Unit subclass: #NullUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EjerciciosPoo-Measure'!

!NullUnit class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 08:07'!
baseUnit
^	self new.! !

!NullUnit class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 07:58'!
convertAmountBaseUnit: aSmallInteger 
	^aSmallInteger ! !

!NullUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 21:56'!
* aUnit
	"comment stating purpose of message"

	^ aUnit.! !

!NullUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 23:07'!
/ aUnit
	"comment stating purpose of message"

	^ (1/aUnit).! !

!NullUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 08:09'!
=anObject
^( anObject isKindOf: NullUnit) 
	! !

!NullUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 08:06'!
baseUnit
 ^	self ! !

!NullUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 23:12'!
dividedUnitFrom: aUnit 
	^aUnit ! !

!NullUnit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 20:48'!
multipliedUnitFrom: aUnit 
	^aUnit ! !

!Unit class methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/12/2013 23:07'!
name: aName convertionFactor: aFactor
^(self new)
initializeName: aName convertionFactor: aFactor;
yourself .! !

!Unit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 00:50'!
* aUnit
	"comment stating purpose of message"
	(aUnit isKindOf: Number) ifTrue:
	[ ^ Measure newWithAmount: aUnit andUnit: self ].
	^ aUnit multipliedUnitFrom: self.! !

!Unit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 11:28'!
/ aUnit
	"comment stating purpose of message"
	self = aUnit ifTrue: [^NullUnit ].
	^ self dividedUnitFrom: aUnit.! !

!Unit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 11:22'!
= anObject 
	
	^ self subclassResponsibility .! !

!Unit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 17:08'!
adaptToNumber: aSmallInteger andSend: aByteSymbol 
	^Measure newWithAmount: aSmallInteger andUnit: self ! !

!Unit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 21:07'!
baseUnit

	^ baseUnit.! !

!Unit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 07:59'!
convertAmountBaseUnit: anAmount
	"comment stating purpose of message"

	^ anAmount .! !

!Unit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/26/2013 19:00'!
convertAmountFromBaseUnit: aNumber
	"comment stating purpose of message"

	^ self subclassResponsibility.! !

!Unit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/12/2013 23:15'!
convertionFactor

	^ convertionFactor! !

!Unit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/27/2013 17:32'!
dividedUnitFrom: aUnit
	^ (DividedUnit newWithNumerator: self andDenominator: aUnit) simplify! !

!Unit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/12/2013 23:10'!
initializeName: aName convertionFactor: aFactor
 name:= aName.
 convertionFactor:= aFactor! !

!Unit methodsFor: 'as yet unclassified' stamp: 'FacundoPippia 5/20/2013 20:14'!
printString 
^name.! !
